* NAMETAG.PRG - by Hugh Hemington, 72447,3475
* 
* This program downloads 3 fonts to an HP LaserJet II and prints
* Avery name tags (35 char. x 13 line 2x4 per page).
* The program was developed for KABC-TV in Los Angeles, for their
* Sales department - so the sample database includes contacts and staff.
* The trick here is that the data is printed using proportionally spaced
* fonts and is CENTERED.  This is done by using a width table for each
* font and having a function track the dot width of each character used.
* I used GLYPHIX fonts for this project.  That program allows the user to 
* generate bitmapped fonts from several different families and also will
* generate a width table which can easily be converted to a database like
* the ones supplied (60, 30, & 20.dbf).  The databases are loaded into arrays
* for speed.  I hope this code is helpful.
*
* load width tables
  PUBLIC gnt1[95], gnt2[95], gnt3[95]
  USE 60
  DO WHILE ! EOF()
    gnt1[recno()] := ASCII+' '+WIDTH
    SKIP
  END
  USE 30
  DO WHILE ! EOF()
    gnt2[recno()] := ASCII+' '+WIDTH
    SKIP
  END
  USE 20
  DO WHILE ! EOF()
    gnt3[recno()] := ASCII+' '+WIDTH
    SKIP
  END
  USE
*
@  4, 9 SAY CENTER('PRINT NAME TAGS',58)
getlist := {}
* these are the absolute dot positions of each nametag
xc1 := 185    && col. 1 margin
xc2 := 1240   && col. 2 margin
xr1 := 500    && row 1 baseline
xr2 := 1150   && row 2 baseline
xr3 := 1800   && row 3 baseline
xr4 := 2450   && row 4 baseline
* the vertical dots to add (down) to space the second and third lines
xa1 := 150    && add for lastname
xa2 := 270    && add for agency name
f1 := '(1X'  && select font 1
f2 := '(2X'  && select font 2
f3 := '(3X'  && select font 3
* center cfirst - 11, clast - 22, aname - 40
pf := '*p'  && abs. pos. command prefix
pc := 'X'  && column axis suffix
pr := 'y'  && row axis suffix
* build blank sheet array
xar := ARRAY(8,3)
xar[1][1] := f1+pf+LTRIM(STR(xr1))+pr
xar[1][2] := f2+pf+LTRIM(STR(xr1+xa1))+pr
xar[1][3] := f3+pf+LTRIM(STR(xr1+xa2))+pr

xar[2][1] := f1+pf+LTRIM(STR(xr1))+pr
xar[2][2] := f2+pf+LTRIM(STR(xr1+xa1))+pr
xar[2][3] := f3+pf+LTRIM(STR(xr1+xa2))+pr

xar[3][1] := f1+pf+LTRIM(STR(xr2))+pr
xar[3][2] := f2+pf+LTRIM(STR(xr2+xa1))+pr
xar[3][3] := f3+pf+LTRIM(STR(xr2+xa2))+pr

xar[4][1] := f1+pf+LTRIM(STR(xr2))+pr
xar[4][2] := f2+pf+LTRIM(STR(xr2+xa1))+pr
xar[4][3] := f3+pf+LTRIM(STR(xr2+xa2))+pr

xar[5][1] := f1+pf+LTRIM(STR(xr3))+pr
xar[5][2] := f2+pf+LTRIM(STR(xr3+xa1))+pr
xar[5][3] := f3+pf+LTRIM(STR(xr3+xa2))+pr

xar[6][1] := f1+pf+LTRIM(STR(xr3))+pr
xar[6][2] := f2+pf+LTRIM(STR(xr3+xa1))+pr
xar[6][3] := f3+pf+LTRIM(STR(xr3+xa2))+pr

xar[7][1] := f1+pf+LTRIM(STR(xr4))+pr
xar[7][2] := f2+pf+LTRIM(STR(xr4+xa1))+pr
xar[7][3] := f3+pf+LTRIM(STR(xr4+xa2))+pr

xar[8][1] := f1+pf+LTRIM(STR(xr4))+pr
xar[8][2] := f2+pf+LTRIM(STR(xr4+xa1))+pr
xar[8][3] := f3+pf+LTRIM(STR(xr4+xa2))+pr

PRIVATE ldld := lcont := SPACE(1)
SET CURSOR ON
@ 11, 2 SAY '(Q)uit or (C)ontinue with name tags? ' GET lcont PICTURE '!' VALID(lcont $'QC')
@ 13, 2 SAY 'Download fonts to printer? (Y/N) ' GET Ldld PICTURE '!' VALID(Ldld $'YN')
READ
SET CURSOR OFF
IF lcont = 'Q' .OR. LASTKEY() = 27
  CLS
  QUIT
END
IF Ldld = 'Y'
  dl_screen := SAVESCREEN(0,0,24,79)
  CLS
  @  8, 2 SAY '**** PLEASE WAIT... DOWNLOADING FONTS ****'
  snd1 := 'DOWNLOAD HELV6065.SFP,1,P > NUL'
  snd2 := 'DOWNLOAD HELV3065.SFP,2,P > NUL'
  snd3 := 'DOWNLOAD HELV2055.SFP,3,P > NUL'
  @ 10, 2 SAY 'Helvetica 60 points...'
  RUN &snd1
  @ 11, 2 SAY 'Helvetica 30 points...'
  RUN &snd2
  @ 12, 2 SAY 'Helvetica 20 points...'
  RUN &snd3
  RESTSCREEN(0,0,24,79,dl_screen)
END
USE T_SAMPLE
GO TOP
Pg := ACLONE(xar)
lcd := 1
DO WHILE ! EOF()
  @ 18, 2 SAY ANAME
  @ 19, 2 SAY PADR(TRIM(CFIRST)+' '+CLAST,40)
  IF lcd = 9  && loaded a page
    @ 20, 2 SAY 'Printing... '
    SET PRINT ON
    SET CONSOLE OFF
    FOR x = 1 TO 8
      FOR y = 1 TO 3
        ?? Pg[x][y]
      NEXT
    NEXT
    EJECT
    SET PRINT OFF
    SET CONSOLE ON
    Pg := ACLONE(xar)
    lcd := 1
    @ 20, 2 SAY '            '
  END
  * load this record
  ln := TRIM(UPPER(CFIRST))
  IF EMPTY(ln)
    SKIP
    LOOP
  END
  * I conditionally cut off the first "word" if it is an initial and there are
  * spaces, indicating another name eg: T. EDGAR becomes EDGAR
  IF '.' $LEFT(ln,5) .AND. ' ' $ln
    ln := SUBSTR(ln,AT(' ',ln)+1)
  END
  * in 60 point font, more than 11 chars. usually don't fit, so try to shorten
  * the name by finding other spaces to cut at...
  IF LEN(ln) > 11
    IF ' ' $ln
      ln := LEFT(ln,AT(' ',ln)-1)
    ELSE
      ln := LEFT(ln,11)
    END
  END
  * cut off a trailing initial
  IF SUBSTR(ln,LEN(ln)-2,1) = ' '
    ln := LEFT(ln,LEN(ln)-2)
  END
  IF STR(lcd,1) $'1357'  && first column
    Pg[lcd][1] += LTRIM(STR(xc1+FJUST(ln,1),4))+pc+ln
    Pg[lcd][2] += LTRIM(STR(xc1+FJUST(TRIM(UPPER(CLAST)),2),4))+pc+TRIM(UPPER(CLAST))
    Pg[lcd][3] += LTRIM(STR(xc1+FJUST(TRIM(UPPER(ANAME)),3),4))+pc+TRIM(UPPER(ANAME))
  ELSE  && second column
    Pg[lcd][1] += LTRIM(STR(xc2+FJUST(ln,1),4))+pc+ln
    Pg[lcd][2] += LTRIM(STR(xc2+FJUST(TRIM(UPPER(CLAST)),2),4))+pc+TRIM(UPPER(CLAST))
    Pg[lcd][3] += LTRIM(STR(xc2+FJUST(TRIM(UPPER(ANAME)),3),4))+pc+TRIM(UPPER(ANAME))
  END
  lcd++
  SKIP
END
IF lcd > 1
  @ 20, 2 SAY 'Printing... '
  SET PRINT ON
  SET CONSOLE OFF
  FOR x = 1 TO 8
    FOR y = 1 TO 3
      ?? Pg[x][y]
    NEXT
  NEXT
  EJECT
  SET PRINT OFF
  SET CONSOLE ON
  @ 20, 2 SAY '            '
END
USE
QUIT

  
FUNCTION FJUST(fl, farr)
fret := ""
fspc := 1
fpnt := fpos := 0
IF farr = 1  && 60 char. font
  FOR x = 1 TO LEN(fl)
    fret := SUBSTR(fl,x,1)
    fpos := ASCAN(gnt1,fret)
    fpnt += VAL(SUBSTR(gnt1[fpos],3))
  NEXT
  RETURN INT((1000-fpnt)/2)
ELSEIF farr = 2  && 30 char. font
  FOR x = 1 TO LEN(fl)
    fret := SUBSTR(fl,x,1)
    fpos := ASCAN(gnt2,fret)
    fpnt += VAL(SUBSTR(gnt2[fpos],3))
  NEXT
  RETURN INT((1000-fpnt)/2)
ELSE
  FOR x = 1 TO LEN(fl)
    fret := SUBSTR(fl,x,1)
    fpos := ASCAN(gnt3,fret)
    fpnt += VAL(SUBSTR(gnt3[fpos],3))
  NEXT
  RETURN INT((1000-fpnt)/2)
END
                   
